<?php
/**
 * Load and show articles
 *
 * Blog
 * @author Martin
 * @version 1.0 - 2014
 * @package MK-Blog
 */

$show_deleted = false;
if (array_key_exists('show_deleted',$_GET)
    && is_user_logged())     {
    if ($_GET['show_deleted'] == "true") {
        $_SESSION['show_deleted'] = true;
    } else {
        $_SESSION['show_deleted'] = false;
    }
    $show_deleted = $_SESSION['show_deleted'];

} elseif (array_key_exists('show_deleted', $_SESSION)
    && is_user_logged()) {
    $show_deleted = $_SESSION['show_deleted'];
}

$query = "SELECT *
        FROM article
        LEFT JOIN user ON article.author = user.username" .
    (($show_deleted) ? "" : " WHERE article.deleted = false")
    . " ORDER BY date DESC";


$result = do_query($db, $query, array());

if (is_user_logged()) {
    echo '<div>

            <a href="?show_deleted=' . ($show_deleted ? "false" : "true") . '">
                ' . ($show_deleted ? "Nezobrazovat smazané" : "Zobrazit smazané") . '
                </a>
        </div>';
}

//set number of articles on page
if ((array_key_exists('number_of_articles', $_GET))
    && (($_GET['number_of_articles'] == 'all') ||
        ((is_numeric($_GET['number_of_articles']))
            && ($_GET['number_of_articles'] >= 1)))
) {
    setcookie('number_of_articles', $_GET['number_of_articles']);
    $number_of_articles_on_page = $_GET['number_of_articles'];
} elseif (!array_key_exists('number_of_articles', $_COOKIE)) {
    setcookie('number_of_articles', 5);
    $number_of_articles_on_page = 5;
} else {
    $number_of_articles_on_page = $_COOKIE['number_of_articles'];
}

//set number of page
$pn = 1;
$total_number_of_pages = 1;
if ($number_of_articles_on_page != 'all') {
    settype($number_of_articles_on_page, "integer");
    $total_number_of_pages = ceil($result->rowCount() / $number_of_articles_on_page);
    if ((array_key_exists('pn', $_GET))
        && (is_numeric($_GET['pn']))
        && ($_GET['pn'] > 1)
        && ($_GET['pn'] <= $total_number_of_pages)
    ) {
        $pn = $_GET['pn'];
        settype($pn, "integer");
    }
}

$data = array();
if ($number_of_articles_on_page != 'all') {
    $query = $query . " LIMIT ?, ?";
    $offset = $number_of_articles_on_page * ($pn - 1);
    $data = array($offset, $number_of_articles_on_page);
}
$db->setAttribute(PDO::ATTR_EMULATE_PREPARES, FALSE);
$statement = do_query($db, $query, $data);

if ($statement->errorCode() != 0) {
    echo "<h2>Nepodařilo se načíst články :(</h2>";
    $errors = $statement->errorInfo();
} else {
    //print articles
    foreach ($statement as $row) {

        $img_query = "SELECT name FROM image WHERE articleid=?";
        $img_data = array($row['articleid']);
        $images = do_query($db, $img_query, $img_data);

        echo
            '<article class="'. (($row['deleted']) ? "deleted" : "") .'">
            <h2>' .
            htmlspecialchars($row['title']) .
            '</h2>
            <p>' .
            htmlspecialchars($row['content']) .
            '</p>';


        echo '<div class="gallery">';

        foreach ($images as $image) {
            echo '<img src="img/gallery/' . $row['articleid'] . '/' . $image['name'] . '" alt="Obrázek přidaný uživatelem k článku ' . $row['title'] . '" />';
        }
        echo '</div>';

        //print admin btns
        if (is_user_logged() && ($_SESSION['user'] == $row['author'])) {
            echo '<div class="btns admin">';
            if ($row['deleted'] == false) {
                echo '
                    <a href="index.php?page=new_article&amp;edit_article=' . $row['articleid'] . '">Upravit článek</a>

                    <a href="index.php?delete_article=' . $row['articleid'] . '">Smazat článek</a>';
            } else {
                echo '<a href="index.php?page=new_article&amp;edit_article=' . $row['articleid'] . '">Obnovit článek</a>';
            }
            echo '</div>';
        }

        echo '
                <div class="details">
                <span>
                    <strong>Autor: </strong>' .
            htmlspecialchars($row['name'] . " " . $row['surname']) .
            '</span>
            <span>
                <strong>Zveřejněno: </strong>' .
            htmlspecialchars(date("j. n. Y v H:i", strtotime($row['date']))) .
            '</span></div>
        </article>';

    }
}

echo '
<div class="footer-navigation">
    <div class="paging">';
if ($number_of_articles_on_page != 'all') {
    if ($pn > 1) echo '<a href="?pn=1" title="První stránka">&lt;&lt;&nbsp;</a>';

    for ($i = -3; $i <= 3; $i++) {
        $page_number = $pn + $i;
        if (($page_number >= 1)
            && ($page_number <= $total_number_of_pages)
        ) {
            echo '&nbsp;<a ';
            if ($i == 0) echo ' class="actual" ';
            echo 'href="?pn=' . $page_number . '">' . $page_number . '</a>&nbsp;';
        }
    }

    if ($pn < $total_number_of_pages) echo '<a href="?pn=' . ($total_number_of_pages) . '" title="Poslední stránka">&nbsp;&gt;&gt;</a>';
}
echo '</div>
    <div class="btns controls">
    <a class="btn pull-left up" href="#">Nahoru</a>
    <div class="pull-right">
        <form method="get">
            <span class="highlighted">Počet výsledků na stránce: </span>
            <select name="number_of_articles" onchange="this.form.submit()">';
$pos_paging = array(1, 3, 5, 10, "all");

foreach ($pos_paging as $paging) {
    $label = $paging;
    $selected = "";
    if ($paging == 'all') $label = 'Vše';
    if ($paging == $number_of_articles_on_page) $selected = "selected";
    echo '<option value="' . $paging . '" ' . $selected . '>' . $label . '</option>';
}

echo '</select>
        </form>
        </div>
    </div>
</div>
<div class="clear">
</div>
';