<!DOCTYPE html>
<html>
<head lang="en">
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Skromný královský blog</title>
    <link href="img/graphics/ico/favicon.png" rel="icon" type="image/png"/>
    <link rel="stylesheet" href="css/styles.css">
    <link rel="stylesheet" href="css/styles-print.css" media="print">
</head>
<body>
<header>
    <div class="title">
        <img src="img/graphics/logo.svg" class="logo" alt="Logo"/>

        <h1>
            Králův blog
        </h1>
    </div>
</header>
<div class="content">
    <?php
    /**
     * Insert content
     *
     * blog
     * @author Martin
     * @version 1.0 - 2014
     * @package MK-Blog
     */
    session_start();

    /**
     * Create database connection
     * @param none
     * @return PDO database
     */
    function initDatabase()
    {
        $dbname = "mysql:host=localhost;dbname=kralmar3";
        $user = "kralmar3";
        $pass = "wa1";
        $db = new PDO($dbname, $user, $pass);
        $db->query("SET NAMES utf8");
        return $db;
    }

    /**
     * Do SQL query
     * @param db PDO database
     * @param query string query
     * @param data array data for query
     * @return PDOStatement result
     */
    function do_query($db, $query, $data)
    {
        $statement = $db->prepare($query);
        $statement->execute($data);
        return $statement;
    }

    /**
     * Get filename by $_GET value
     * @param none
     * @return string filename
     */
    function get_page()
    {
        $file = "articles.php";
        if (array_key_exists('page', $_GET)) {
            $page = $_GET['page'];
            if ($page == "login") {
                $file = "login.php";
            } elseif ($page == "register") {
                $file = "register.php";
            } elseif ($page == 'new_article') {
                $file = "newArticle.php";
            } else {
                $file = "pageNotFound.php";
            }
        }
        return $file;
    }

    /**
     * is user logged in
     * works with session data
     * @return bool is user logged in
     */
    function is_user_logged() {
        return (array_key_exists('logged', $_SESSION)
                && ($_SESSION['logged'] == true)
                && array_key_exists('user', $_SESSION));
    }

    $db = initDatabase();

    $get_page = get_page();
    include('statusbar.php');
    include($get_page);
    if ($get_page != "articles.php") {
        echo '
                <div class="left-aligned">
                    <a class="btn back" href="index.php">Hlavní strana</a>
                </div>';
    }

    ?>
</div>
<footer>
    <div class="content">
        <?php
        include("footer.php");
        ?>
    </div>
</footer>

</body>
</html>