<?php
/**
 * Create and edit article
 *
 * blog
 * @author Martin
 * @version 1.0 - 2014
 * @package MK-Blog
 */

//is user autorized
if (is_user_logged()) {
    $user = $_SESSION['user'];
    $completed = true;
    $article_id = null;
    $title = "";
    $content = "";

    if (array_key_exists('edit_article', $_GET)) {
        $article_id = $_GET['edit_article'];
        $query = "SELECT * FROM article WHERE articleid=?";
        $data = array($article_id);
        $statement = do_query($db, $query, $data);
        if ($statement->rowCount() == 1) {
            foreach ($statement as $row) {
                if ($row['author'] == $user) {
                    $title = $row['title'];
                    $content = $row['content'];
                } else {
                    echo "Nemáte oprávnění k editaci tohoto článku";
                    $article_id = null;
                }
            }
        } else {
            echo "Tento článek neexistuje.";
            $article_id = null;
        }
    }

    if (array_key_exists('title', $_POST)) {
        $title = $_POST['title'];
    } else $completed = false;
    if (array_key_exists('content', $_POST)) {
        $content = $_POST['content'];
    } else $completed = false;

    if ($completed) {
        if (strlen($title) > 0) {
            if ($article_id != null) {
                $query = "UPDATE article SET title=?, content=?, deleted=FALSE WHERE articleid=?";
                $data = array($title, $content, $article_id);
            } else {
                $query = "INSERT INTO article (title, content, author) VALUES (?,?,?)";
                $data = array($title, $content, $user);
            }

            $statement = do_query($db, $query, $data);

            if ($article_id == null) {
                $article_id = $db->lastInsertId();
            }

            //file save
            $path = "img/gallery/$article_id/";
            if ((($_FILES['images']['type'] == "image/png")
                    || ($_FILES['images']['type'] == "image/jpg")
                    || ($_FILES['images']['type'] == "image/jpeg"))
                && ($_FILES['images']['size'] < 1000000)
            ) {

                if (!file_exists($path)) {
                    mkdir($path);
                }
                if (file_exists($path . $_FILES['images']['name'])) {
                    echo "Obrázek s názvem " . $_FILES['images']['name'] . " je již nahrán.";
                } else {
                    move_uploaded_file($_FILES['images']['tmp_name'], $path . $_FILES['images']['name']);
                    $img_query = "INSERT INTO image (articleid, name) VALUES (?,?)";
                    $img_data = array($article_id, $_FILES['images']['name']);
                    $img_statement = $db->prepare($img_query);
                    $img_statement->execute($img_data);
                }
            } elseif (!empty($_FILES['images']['name'])) {
                echo "Neplatný typ souboru nebo příliš veliký obrázek. Velikost obrázku musí být menší, než 1MB.";
            } else {
                if ($statement->errorCode() == 0) {
                    header("Location: index.php");
                }
            }
        }
    }

    $img_query = "SELECT name FROM image WHERE articleid=?";
    $img_data = array($article_id);
    $images = $db->prepare($img_query);
    $images->execute($img_data);

    //print form
    echo '<h2>';
    if ($article_id == null) {
        echo 'Vytvořit nový článek';
    } else {
        echo 'Editovat článek';
    }

    echo '</h2>
            <form id="new-article-form" class="new-article" action="';
    if ($article_id != null) {
        echo 'index.php?page=new_article&amp;edit_article=' . $article_id;
    }
    echo '" method="post" enctype="multipart/form-data">
                <label class="left-aligned">
                    <input class="title';
    if (($completed) && (strlen($title) == 0)) {
        echo ' invalid';
    }
    echo '" placeholder="Nadpis článku" autocomplete="off" required type="text" name="title" value="' . htmlspecialchars($title) . '"/>
                *</label>
                <label/>
                    <textarea placeholder="Text článku" class="article-content" name="content">' . htmlspecialchars($content) . '</textarea>
                </label>
                <div class="gallery">';

    foreach ($images as $image) {
        echo '<img src="img/gallery/' . $article_id . '/' . $image['name'] . '">';
    }

    echo '</div>
            <div>
            <input type="file" name="images" value="" />
          </div>
                <div class="submit">
                * Povinný údaj
                    <input type="submit" id="submit" value="Uložit" />
                </div>
            </form>';
} else {
    echo 'Nepovolený přístup na stránku. Pro přidání článku se musíš <a href="index.php?page=login">přihlásit.</a>';
}

?>
<script type="text/javascript">
    var submitBtn = document.querySelector("#submit");
    var form = document.querySelector("#new-article-form");

    var save = function (e) {
        submitBtn.value = "Ukládám";
        submitBtn.disabled = true;
        submitBtn.className = "disabled";
    };

    form.addEventListener("submit", save);
</script>
