<?php
/**
 * New user registration
 *
 * blog
 * @author Martin
 * @version 1.0 - 2014
 * @package MK-Blog
 */

$completed = true;

/**
 * keys (code names) of form values
 * @var array(string)
 */
$form_keys = array("username", "email", "name", "surname", "password", "verification");
$form_values = array();
$form_values_ok = array();

/**
 * labels for the form
 * @var array(string)
 */
$form_labels = array(
    "username" => "Uživatelské jméno",
    "email" => "Email",
    "name" => "Křestní jméno",
    "surname" => "Příjmení",
    "password" => "Heslo",
    "verification" => "Ověření hesla",
);

/**
 * types of the form values
 * @var array(string)
 */
$form_types = array(
    "username" => "text",
    "email" => "email",
    "name" => "text",
    "surname" => "text",
    "password" => "password",
    "verification" => "password",
);

//get form values
foreach ($form_keys as $key) {
    if (array_key_exists($key, $_POST)) {
        $form_values[$key] = $_POST[$key];
    } else {
        $form_values[$key] = "";
    }
    $form_values_ok[$key] = true;
}

//form filled check
foreach ($form_keys as $key) {
    if (array_key_exists($key, $_POST)) {
        $form_values[$key] = $_POST[$key];
    } else $completed = false;
}

//user exists check
$query = "SELECT * FROM user WHERE username = ?";
$data = array($form_values['username']);
$statement = do_query($db, $query, $data);

//form check and registration
if (($form_values_ok['email'] = ((strlen($form_values['email']) > 4)
        && (strpos($form_values['email'], '@') > 0)
        && (strpos($form_values['email'], '.', strpos($form_values['email'], '@') + 1))))
    & ($form_values_ok['name'] = (strlen($form_values['name']) > 0))
    & ($form_values_ok['surname'] = (strlen($form_values['surname']) > 0))
    & ($form_values_ok['password'] = (strlen($form_values['password']) > 4))
    & ($form_values_ok['verification'] = ($form_values['password'] == $form_values['verification'])
    & $form_values_ok['username'] = ((strlen($form_values['username']) > 0)
            && (strlen($form_values['username']) < 10)
            && (!preg_match('/[^a-zA-Z0-9]+/', $form_values['username']))
            && ($statement->rowCount() < 1)))) {

    $query = "INSERT INTO user (username, email, name, surname, password) VALUES (?,?,?,?,?)";
    $data = array($form_values['username'], $form_values['email'], $form_values['name'], $form_values['surname'], crypt($form_values['password']));
    $statement = do_query($db, $query, $data);

    header("Location: index.php?page=login");
}

echo '
            <h2>
                Registrace nového uživatele
            </h2>
            <form class="register" id="register" method="post" >';

//print the form
foreach ($form_keys as $key) {
    echo '<label>
             <span class="label">' . $form_labels[$key] . '</span>
             <input ';
    if ((!$form_values_ok[$key]) && ($completed)) echo 'class="invalid" title="Chybně zadaná hodnota" ';
    echo 'type="' . $form_types[$key] . '" name="' . $key . '" id="' . $key . '" value="' . $form_values[$key] . '" required autocomplete="off"/>
          *</label>';
}
echo '<div class="submit">
                * Povinný údaj
                <input type="submit" value="Přihlásit" />
          </div>
        </form>';

?>

<script type="text/javascript">
    var usernameField = document.querySelector("#username");
    var emailField = document.querySelector("#email");
    var nameField = document.querySelector("#name");
    var surnameField = document.querySelector("#surname");
    var passwordField = document.querySelector("#password");
    var verificationField = document.querySelector("#verification");
    var form = document.querySelector("#register");
    var completed = true;

    var verify = function (element) {
        if (element.value.length > 0) {
            element.className = "";
            element.title = "";
        } else {
            element.className = "invalid";
            element.title = "Toto pole je třeba vyplnit";
            completed = false;
        }
    };

    var response = function (e) {
        if ((e.target.responseText != "1")
            && (usernameField.value.length > 0)
            && (usernameField.value.length < 10)
            && (/^[a-zA-Z0-9]*$/.test(usernameField.value) == true)) {
            usernameField.className = "";
            usernameField.title = "";
        } else {
            usernameField.className = "invalid";
            usernameField.title = "Zadané uživatelské jméno již existuje nebo obsahuje nepovolené znaky";
        completed = false;
        }
    };

    var verifyUser = function (e) {
        var request = new XMLHttpRequest();
        request.open("get", "verifyuser.php?username=" + usernameField.value, true);
        request.send();
        request.addEventListener("load", response);
    };

    var verifyEmail = function (e) {
        if ((emailField.value.indexOf("@") > 0)
        && (emailField.value.lastIndexOf(".") > emailField.value.indexOf("@") + 1)) {
            emailField.className = "";
            emailField.title = "";
        } else {
            emailField.className = "invalid";
            emailField.title = "Neplatný formát emailové adresy";
        completed = false;
        }
    };

    var verifyPassword = function (e) {
        if (passwordField.value.length > 4) {
            passwordField.className = "";
            passwordField.title = "";
        } else {
            passwordField.className = "invalid";
            passwordField.title = "Heslo musí být alespoň 5 znaků dlouhé";
        completed = false;
        }
    };

    var verifyPasswordVerification = function (e) {
        if (verificationField.value === passwordField.value){
            verificationField.className = "";
            verificationField.title = "";
        }else {
            verificationField.className = "invalid";
            verificationField.title = "Zadaná hesla se neshodují";
            completed = false;
        }
    };

    var verifyAll = function (e) {
        verifyUser();
        verifyEmail();
        verify(nameField);
        verify(surnameField);
        verifyPassword();
        verifyPasswordVerification();
        if (!completed) {
            e.preventDefault();
        }
    };

    usernameField.addEventListener("keyup", verifyUser);
    usernameField.addEventListener("blur", verifyUser);
    nameField.addEventListener("blur", function () {verify(nameField)});
    surnameField.addEventListener("blur", function () {verify(surnameField)});
    passwordField.addEventListener("blur", verifyPassword);
    verificationField.addEventListener("blur", verifyPasswordVerification);
    emailField.addEventListener("blur", verifyEmail);
    form.addEventListener("submit", verifyAll);

</script>